/*******************************************************************************/
//  Bernard Lidicky - 1999
//  Hippo Games
//  CZerw
//  CZewri.cpp
/*******************************************************************************/

#include "stdafx.h"
#include "CZerwi.h"
// casti hry
#include "menu1.h"
#include "about.h"
#include "bbuttonek.h"

#include "CDI.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


int level;
CCZerwiApp theApp;

/*******************************************************************************/
BEGIN_MESSAGE_MAP(CCZerwiApp, CWinApp)
	//{{AFX_MSG_MAP(CCZerwiApp)
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()
/*******************************************************************************/
CCZerwiApp::CCZerwiApp()
{
	srand((unsigned)time(NULL));  // inicializace generatoru nahodnych cisel
}
/*******************************************************************************/
CCZerwiApp::~CCZerwiApp()
{
	WriteProfileInt("Nastaveni","level",level);

	if( lpDDSPrimary != NULL )  lpDDSPrimary->Release();
	lpDDSPrimary = NULL;
	
  if( lpDD != NULL )  lpDD->Release();
	lpDD = NULL;
}	
/*******************************************************************************/
BOOL CCZerwiApp::InitInstance()
{
#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	SetRegistryKey(_T("Hippo Games")); // nastaveni klice k registrum

	level = GetProfileInt("Nastaveni","level",1);
	if(level < 1) level = 1;
	else if(level > 20) level = 20;

	CMainFrame* pFrame = new CMainFrame;
	m_pMainWnd = pFrame;

	// The one and only window has been initialized, so show and update it.
	pFrame->ShowWindow(SW_SHOW);

	if (InitDirectDraw() == FALSE) {
		TRACE("Direct Draw failed\n");
		return FALSE;
	}
	if (input.Create(this->m_hInstance) != DI_OK) {
		TRACE("Direct Input failed\n");
		return FALSE;
	}

	pFrame->UpdateWindow();
	pFrame->SendMessage(WM_INITED); // oznamime inicializaci

	return TRUE;
}
/*******************************************************************************/
BOOL CCZerwiApp::InitDirectDraw()
{
	// zavedeni DirectDraw
   DDSURFACEDESC       ddsd;
   DDSCAPS             ddscaps;
   HRESULT             ddrval;

	// tvoreni objektu DirectDraw
    ddrval = DirectDrawCreate( NULL, &lpDD, NULL ); // z lpDD je dd objekt
    if( ddrval != DD_OK ) return FALSE;

	 
	// Get exclusive mode - spojeni s objektem okna
	ddrval = lpDD->SetCooperativeLevel( m_pMainWnd->m_hWnd,  
				     DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN | DDSCL_ALLOWREBOOT);//| DDSCL_ALLOWREBOOT
    if( ddrval != DD_OK ) return FALSE;

	 // zmena rozliseni obrazovky 640*480*16bit. grafika
	 ddrval = lpDD->SetDisplayMode( 640, 480, 16 );  // zmena rozliseni
    if( ddrval != DD_OK ) return FALSE;

	// Create the primary surface with 1 back buffer - tvorba surfacu
	ddsd.dwSize = sizeof( ddsd );
	ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
	ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDSCAPS_FLIP | DDSCAPS_COMPLEX;
	ddsd.dwBackBufferCount = 1; // pocet pouze pametovych obrazovek - na fillig
	ddrval = lpDD->CreateSurface( &ddsd, &lpDDSPrimary, NULL );
	if( ddrval != DD_OK ) return FALSE;

	// Get a pointer to the back buffer 
	ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
   ddrval = lpDDSPrimary->GetAttachedSurface(&ddscaps, 
							  &lpDDSBack);
	if( ddrval != DD_OK ) return FALSE;
	
	DDSetColorKey(lpDDSPrimary, RGB(255,0,255)); // barva, ktera se bure pripadne ignorovat - ruzova
	DDSetColorKey(lpDDSBack, RGB(255,0,255));

	// zniceni ramecku okolo
	CRect Rect;
	SetRect(&Rect, 0, GetSystemMetrics(SM_CYCAPTION), GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN));
	AdjustWindowRectEx(&Rect, WS_POPUP | WS_CAPTION, FALSE, 0);
	m_pMainWnd->SetWindowPos(NULL, Rect.left, Rect.top, Rect.right-Rect.left, Rect.bottom-Rect.top, SWP_NOACTIVATE | SWP_NOZORDER);

	return TRUE;
}
/*******************************************************************************/
