/*******************************************************************************/
//  Bernard Lidicky - 1999
//  Hippo Games
//  CZerw
//  hra.cpp
/*******************************************************************************/

#include "stdafx.h"
#include "CZerwi.h"
#include "Hra.h"
#include "CDI.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// define matematiky 
#define SIN15 (0.2588)
#define COS15 (0.9659)
#define SIN30 (0.5   )
#define COS30 (0.8660)
#define CON45 (0.7071)

#define LIMIT_LOW   10
#define LIMIT_HI    15

//******************************************************************************
CHra::CHra()
{
	m_lpDDAll = DDLoadBitmap(lpDD,"IDB_GROUND",0,0);
	if (m_lpDDAll == NULL) {
		TRACE("m_lpDDAll == NULL");
		AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);
	}

	m_lpDDHra = DDLoadBitmap(lpDD,"IDB_HRA",0,0);
	if (m_lpDDHra == NULL) {
		TRACE("m_lpDDHra == NULL");
		AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);
	}

	
	DDSetColorKey(m_lpDDHra,RGB(255,0,255));
	
	// tvorba fontu
	m_font.CreateFont(15,0,0,0,FW_BOLD,0,0,0,1,OUT_DEFAULT_PRECIS, 
						   CLIP_DEFAULT_PRECIS,PROOF_QUALITY,DEFAULT_PITCH,
							"Verdena"); // Verdena - Times New Roman
	m_key.Create(&input,&AfxGetMainWnd()->m_hWnd);
}
//******************************************************************************
CHra::~CHra()
{
	m_font.Detach();


	if (m_lpDDAll != NULL) 
		m_lpDDAll->Release();
	m_lpDDAll = NULL;


	if(m_lpDDHra != NULL)
		m_lpDDHra->Release();
	m_lpDDHra = NULL;

}
//******************************************************************************
void CHra::OnTimer()
{
	if(m_game) 
		for(int i = 0;i < m_players; i++) {
			UpdateSmer(i);
			UpdateSpeed(i);
		}
	TestKeys();
	Move(); // test na m_game obsahuje uvnitr
	if (m_game) TestBonus();
	Draw();
	if (m_game) TestCrash();
}
//******************************************************************************
void CHra::Move()
{	
	st_cast pt;
	CPoint  pt2,pt3;
	// zpracovani hadu / czerwu
	for(int had = 0; had < m_players; had++) 
		if(m_czerwi[had].anim == 0)
			if(m_game) {
				// zpracovani hlavy
				pt = m_czerwi[had].telo.RemoveHead();
				pt3 = pt.op;
				pt.op = pt.p;
				pt.p.x = (m_czerwi[had].x_pos_d += m_czerwi[had].x_speed);
				pt.p.y = (m_czerwi[had].y_pos_d += m_czerwi[had].y_speed);
				m_czerwi[had].telo.AddTail(pt);
	
				// zpracovani tela
				for(int i = 0; i+1 < m_czerwi[had].telo.GetCount(); i++) {
					pt = m_czerwi[had].telo.RemoveHead();
					pt2 = pt.op;
					pt.op = pt.p;
					pt.p  = pt3;
					pt3   = pt2;
					m_czerwi[had].telo.AddTail(pt);
				}

			}
			else;
		else  // had je mrtvej -> posun animace
			if(++m_czerwi[had].anim < 7) m_czerwi[had].bmp_y = 21 + m_czerwi[had].anim * 21;		
}
//******************************************************************************
void CHra::NewGame(int Players, bool dead)
{
	st_cast pt;

	for(int i = 0; i < Players; i++) {
		while(m_czerwi[i].telo.GetCount() > 0) m_czerwi[i].telo.RemoveTail();
		m_czerwi[i].bmp_y = i*21;
		m_czerwi[i].bodu = 0;
		m_czerwi[i].x_pos_d = 400 - 200 * i;
		m_czerwi[i].y_pos_d = 400;
		m_czerwi[i].smer = 0;
		m_czerwi[i].x_speed = 0;
		m_czerwi[i].y_speed = -1;
		m_czerwi[i].zataceni = 0;
		m_czerwi[i].speed = 7;
		m_czerwi[i].anim  = 0;
		m_czerwi[i].kills = 0;
		pt.p.x = m_czerwi[i].x_pos_d;
		pt.p.y = m_czerwi[i].y_pos_d;
		pt.op = pt.p;
		m_czerwi[i].telo.AddHead(pt);
		m_czerwi[i].telo.AddTail(pt);
		m_czerwi[i].telo.AddTail(pt);
		m_czerwi[i].telo.AddTail(pt);
		m_czerwi[i].telo.AddTail(pt);
		m_czerwi[i].telo.AddTail(pt);
	}

	m_players = Players;
	if(m_players == 2) // pri hry vice hracu se hadi zvetsuji pomaleji
		if(level == 1) m_obtiznost = 1;
		else m_obtiznost = level - 1;
	else m_obtiznost = level;

	m_game = true;
	m_dead = dead;

	UpdateBonus();
	UpdateBonus(FALSE);
}
//******************************************************************************
void CHra::OnKeyDown(UINT nChar)
{
	switch (nChar) {
	case VK_ESCAPE :
		if(m_game) AfxGetApp()->m_pMainWnd->PostMessage(WM_MENU);
		else ShowWinList();
		break;
	case VK_SPACE :
		if(!m_game) 
			if(m_dead) DeadCont();
			else ShowWinList();
		break;
	}
}
//******************************************************************************
void CHra::Activate()
{
	ZobrazKurzor(FALSE);

}
//******************************************************************************
void CHra::UpdateSmer(int i)
{ 
	if((m_czerwi[i].smer += m_czerwi[i].zataceni) > 23)
		m_czerwi[i].smer = 0;
	else if(m_czerwi[i].smer < 0) m_czerwi[i].smer = 23;
}
//******************************************************************************
void CHra::UpdateSpeed(int i)
{
	int j = m_czerwi[i].speed;
	
	switch(m_czerwi[i].smer) {
	case 0 :
		m_czerwi[i].x_speed = 0;
		m_czerwi[i].y_speed = -j;
		break;
	case 1 :
		m_czerwi[i].x_speed =  j * SIN15;
		m_czerwi[i].y_speed = -j * COS15;
		break;
	case 2 :
		m_czerwi[i].x_speed =  j * SIN30;
		m_czerwi[i].y_speed = -j * COS30;
		break; 
	case 3 :
		m_czerwi[i].x_speed =  j * CON45;
		m_czerwi[i].y_speed = -j * CON45;
		break;
	case 4 :
		m_czerwi[i].x_speed =  j * COS30;
		m_czerwi[i].y_speed = -j * SIN30;
		break;
	case 5 :
		m_czerwi[i].x_speed =  j * COS15;
		m_czerwi[i].y_speed = -j * SIN15;
		break;
	case 6 :
		m_czerwi[i].x_speed = j;
		m_czerwi[i].y_speed = 0;
		break;
	case 7 :
		m_czerwi[i].x_speed = j * COS15;
		m_czerwi[i].y_speed = j * SIN15;
		break;
	case 8 :
		m_czerwi[i].x_speed = j * COS30;
		m_czerwi[i].y_speed = j * SIN30;
		break;
	case 9 :
		m_czerwi[i].x_speed = j * CON45;
		m_czerwi[i].y_speed = j * CON45;
		break;
	case 10 :
		m_czerwi[i].x_speed = j * SIN30;
		m_czerwi[i].y_speed = j * COS30;
		break;
	case 11 :
		m_czerwi[i].x_speed = j * SIN15;
		m_czerwi[i].y_speed = j * COS15;
		break;
	case 12 :
		m_czerwi[i].x_speed = 0;
		m_czerwi[i].y_speed = j;
		break;
	case 13 :
		m_czerwi[i].x_speed = -j * SIN15;
		m_czerwi[i].y_speed =  j * COS15;
		break;
	case 14 :
		m_czerwi[i].x_speed = -j * SIN30;
		m_czerwi[i].y_speed =  j * COS30;
		break;
	case 15 :
		m_czerwi[i].x_speed = -j * CON45;
		m_czerwi[i].y_speed =  j * CON45;
		break;
	case 16 :
		m_czerwi[i].x_speed = -j * COS30;
		m_czerwi[i].y_speed =  j * SIN30;
		break;
	case 17 :
		m_czerwi[i].x_speed = -j * COS15;
		m_czerwi[i].y_speed =  j * SIN15;
		break;
	case 18 :
		m_czerwi[i].x_speed = -j;
		m_czerwi[i].y_speed = 0;
		break;
	case 19 :
		m_czerwi[i].x_speed = -j * COS15;
		m_czerwi[i].y_speed = -j * SIN15;
		break;
	case 20 :
		m_czerwi[i].x_speed = -j * COS30;
		m_czerwi[i].y_speed = -j * SIN30;
		break;
	case 21 :
		m_czerwi[i].x_speed = -j * CON45;
		m_czerwi[i].y_speed = -j * CON45;
		break;
	case 22 :
		m_czerwi[i].x_speed = -j * SIN30;
		m_czerwi[i].y_speed = -j * COS30;
		break;
	case 23 :
		m_czerwi[i].x_speed = -j * SIN15;
		m_czerwi[i].y_speed = -j * COS15;
		break;
	}
}
//******************************************************************************
void CHra::TestCrash()
{
	int j,k;
	st_cast p1,p2;
	CPoint  p;

	for(int i = 0; i < m_players; i++) {
		if(i == 0) j = 1; // ID druheho hada
		else j = 0;
		// test na bourani do steny
		if((m_czerwi[i].x_pos_d < 30) ||
			(m_czerwi[i].y_pos_d < 30) ||
			(m_czerwi[i].x_pos_d > 610) ||
			(m_czerwi[i].y_pos_d > 450)) {
			m_game = false;
			if(m_czerwi[i].anim == 0) m_czerwi[j].kills++;
			m_czerwi[i].anim = 1;
		}
		// test na bourani do sebe
		// ziskame pozici hlavy
		p1 = m_czerwi[i].telo.RemoveHead();
		m_czerwi[i].telo.AddTail(p1);
		p = p1.p;
		for(k = 0; k < 5; k++){ // aby had nenarazil hned v zacatku
			p1 = m_czerwi[i].telo.RemoveHead();
			m_czerwi[i].telo.AddTail(p1);
		}
		for(k = 0; k + 6 < m_czerwi[i].telo.GetCount(); k++) {
			p1 = m_czerwi[i].telo.RemoveHead();
			m_czerwi[i].telo.AddTail(p1);	
			if((abs(p1.p.x - p.x) < 20) &&
				(abs(p1.p.y - p.y) < 20)) {
				m_game = false;
				if(m_czerwi[i].anim == 0) m_czerwi[j].kills++;
				m_czerwi[i].anim = 1;
			}
		}
		// test na druheho hada
		if(m_players > 1) {
			for(k = 0; k < m_czerwi[j].telo.GetCount(); k++) {
				p1 = m_czerwi[j].telo.RemoveHead();
				m_czerwi[j].telo.AddTail(p1);	
				if((abs(p1.p.x - p.x) < 20) &&
					(abs(p1.p.y - p.y) < 20)) {
					m_game = false;
					if(m_czerwi[i].anim == 0) m_czerwi[j].kills++;
					m_czerwi[i].anim = 1;
				}
			}
		}  //if(m_players > 1)
	} //for(int i = 0; i < m_players; i++)
}
//******************************************************************************
void CHra::Draw()
{

	CRect rcRect;
	st_cast pt;
	HRESULT ddrval;
	int had;
	int i,j;

	int score;
	HDC hdc;
	CString s;

	rcRect.SetRect(0,0,640,480);
	// placneme pozadi
	while( 1 )   {
	   ddrval = lpDDSBack->BltFast( 0, 0, m_lpDDAll,
		  &rcRect,DDBLTFAST_NOCOLORKEY); // _DESTCOLORKEY NOCOLORKEY
		if( ddrval == DD_OK )  break;
		if( ddrval == DDERR_SURFACELOST ) Restore();
		if( ddrval != DDERR_WASSTILLDRAWING ) break;
	}
	// nakreslime bonusy
	while( 1 )   {
	   ddrval = lpDDSBack->BltFast( m_bonus.pos.x-10, m_bonus.pos.y-10, m_lpDDHra,
		  &m_bonus.rect,DDBLTFAST_SRCCOLORKEY); // _DESTCOLORKEY NOCOLORKEY
		if( ddrval == DD_OK )  break;
		if( ddrval == DDERR_SURFACELOST ) Restore();
		if( ddrval != DDERR_WASSTILLDRAWING ) break;
	}
	// zobrazeni bodu
	rcRect.SetRect(0,42,20,62);
	while( 1 )   {
	   ddrval = lpDDSBack->BltFast( m_bod.x-10, m_bod.y-10, m_lpDDHra,
		  &rcRect,DDBLTFAST_SRCCOLORKEY); // _DESTCOLORKEY NOCOLORKEY
		if( ddrval == DD_OK )  break;
		if( ddrval == DDERR_SURFACELOST ) Restore();
		if( ddrval != DDERR_WASSTILLDRAWING ) break;
	}
	// zpracovani hada
	for(had = 0; had < m_players; had++) {
		j = 0;
		// zpracovani tela

		for(i = 0; i+1 < m_czerwi[had].telo.GetCount(); i++) {
			if((++j)%10 == 0) 
				rcRect.SetRect(42,m_czerwi[had].bmp_y,62,m_czerwi[had].bmp_y+20);
			else
				rcRect.SetRect(21,m_czerwi[had].bmp_y,41,m_czerwi[had].bmp_y+20);
			pt = m_czerwi[had].telo.RemoveTail();
			while( 1 )   {
			   ddrval = lpDDSBack->BltFast( pt.p.x-10, pt.p.y-10, m_lpDDHra,
				  &rcRect,DDBLTFAST_SRCCOLORKEY);
				if( ddrval == DD_OK )  break;
				if( ddrval == DDERR_SURFACELOST ) Restore();
				if( ddrval != DDERR_WASSTILLDRAWING ) break;
			}
			m_czerwi[had].telo.AddHead(pt);
		}
		// zpracovani hlavy
		rcRect.SetRect(0,m_czerwi[had].bmp_y,20,m_czerwi[had].bmp_y+20);
		pt = m_czerwi[had].telo.RemoveTail();
		while( 1 )   {
		   ddrval = lpDDSBack->BltFast( pt.p.x-10, pt.p.y-10, m_lpDDHra,
			  &rcRect,DDBLTFAST_SRCCOLORKEY);
			if( ddrval == DD_OK )  break;
			if( ddrval == DDERR_SURFACELOST ) Restore();
			if( ddrval != DDERR_WASSTILLDRAWING ) break;
		}
		m_czerwi[had].telo.AddHead(pt);
	}
	// napsani poctu bodu
	lpDDSBack->GetDC(&hdc);
	SetBkColor(hdc,RGB(0,0,0));
	if((m_players == 2) && (m_dead)){
		rcRect.SetRect(530,462,630,678);  // 1. had ( zelenej )
		SetTextColor(hdc,RGB(0,255,0)); 
		s.Format("%d",m_czerwi[0].kills);
		DrawText(hdc,s,s.GetLength(),&rcRect,DT_CENTER|DT_VCENTER);
		rcRect.SetRect(10,462,110,678);  // 2. had ( modrej )
		SetTextColor(hdc,RGB(0,0,255)); 
		s.Format("%d",m_czerwi[1].kills);
		DrawText(hdc,s,s.GetLength(),&rcRect,DT_CENTER|DT_VCENTER);
	}
	else {
		if(m_players > 1) score = m_czerwi[0].bodu + m_czerwi[1].bodu;
		else score = m_czerwi[0].bodu;
		rcRect.SetRect(270,462,370,678);
		if(score < LIMIT_LOW) 
			SetTextColor(hdc,RGB(255,0,0)); 
		else 
			if(score > LIMIT_HI)
				SetTextColor(hdc,RGB(0,255,0)); 
			else 
				SetTextColor(hdc,RGB(255,128,0));
		s.Format("%d",score);
		DrawText(hdc,s,s.GetLength(),&rcRect,DT_CENTER|DT_VCENTER);
	}

	lpDDSBack->ReleaseDC(hdc);
}
//******************************************************************************
void CHra::Restore()
{
	m_lpDDAll->Restore();
	m_lpDDHra->Restore();
	DDReLoadBitmap(m_lpDDAll,"IDB_GROUND");
	
	DDReLoadBitmap(m_lpDDHra,"IDB_HRA");

	DDSetColorKey(m_lpDDHra,RGB(255,0,255));
}
//******************************************************************************
void CHra::UpdateBonus(BOOL bonus)
{
	st_cast p2;
	CPoint pt;
	bool   podm = true;
	// nalezeni volneho mista
	while(podm){
		podm = false;
		pt.x = Nahoda(580) + 30;
		pt.y = Nahoda(420) + 30;
		for(int i = 0; i < m_players; i++)
			for(int j = 0; j < m_czerwi[i].telo.GetCount(); j++){
				p2 = m_czerwi[i].telo.RemoveHead();
				if((abs(p2.p.x - pt.x) <= 25) && 
					(abs(p2.p.y - pt.y) <= 25)) podm = true;
				m_czerwi[i].telo.AddTail(p2);
			}
	}

	if(bonus == TRUE) {
		while((m_bonus.hodnota = Nahoda(3) - 1)==0);
		m_bonus.pos = pt;
		m_bonus.time_left = 100 + Nahoda(50);
		if(m_bonus.hodnota != -1) m_bonus.rect.SetRect(21,42,41,62);
		else m_bonus.rect.SetRect(42,42,62,62);
	}
	else 
	{
		m_bod = pt;
	}
}
//******************************************************************************
void CHra::TestBonus()
{
	st_cast point;
	
	for(int i = 0; i < m_players; i++){
		if((abs(m_czerwi[i].x_pos_d - m_bod.x) <= 20) && 
			(abs(m_czerwi[i].y_pos_d - m_bod.y) <= 20)) {
			point = m_czerwi[i].telo.GetTail();
			for(int j = 0; j < m_obtiznost; j++) // prodlouzime hada
					  m_czerwi[i].telo.AddTail(point);
			m_czerwi[i].bodu++;
			UpdateBonus(FALSE);
		}
		// test na bonusy
		if((abs(m_czerwi[i].x_pos_d - m_bonus.pos.x) <= 20) && 
			(abs(m_czerwi[i].y_pos_d - m_bonus.pos.y) <= 20)) {
			if((m_czerwi[i].speed += m_bonus.hodnota) > 10) m_czerwi[i].speed = 10;
			else if(m_czerwi[i].speed < 4) m_czerwi[i].speed = 4;
			UpdateBonus();
		}
	}
	if(--m_bonus.time_left < 0) UpdateBonus();
}
//******************************************************************************
void CHra::ShowWinList()
{
	if(m_dead) {
		AfxGetApp()->m_pMainWnd->PostMessage(WM_MENU);
		return;
	}

	int score;
	if(m_players > 1) score = m_czerwi[0].bodu + m_czerwi[1].bodu;
	else score = m_czerwi[0].bodu;
	
	if(score < LIMIT_LOW) if(level > 1) level--;
	if(score > LIMIT_HI) if(level < 20) level++;

	AfxGetApp()->m_pMainWnd->PostMessage(WM_MENU);
}
//******************************************************************************
void CHra::TestKeys()
{
	m_key.Update();

	if(m_key.m_Keys[DIK_LEFT] & 0x80)
		m_czerwi[0].zataceni = -1;
	else 
		if(m_key.m_Keys[DIK_RIGHT] & 0x80)
			m_czerwi[0].zataceni = 1;
		else 
			m_czerwi[0].zataceni = 0;

	if(m_key.m_Keys[DIK_A] & 0x80)
		m_czerwi[1].zataceni = -1;
	else 
		if(m_key.m_Keys[DIK_S] & 0x80)
			m_czerwi[1].zataceni = 1;
		else 
			m_czerwi[1].zataceni = 0;
}
//******************************************************************************
void CHra::DeadCont()
{
	int a = m_czerwi[0].kills;
	int b = m_czerwi[1].kills;
	NewGame(2);
	m_dead = true;
	m_czerwi[0].kills = a;
	m_czerwi[1].kills = b;
}
