// Hra.h: interface for the CHra class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HRA_H__5B2CB4C0_4197_11D3_8F74_83A671FF75B3__INCLUDED_)
#define AFX_HRA_H__5B2CB4C0_4197_11D3_8F74_83A671FF75B3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "cdi.h"

typedef struct {
	CPoint pos;  // umisteni na hraci plose
	int    hodnota;
	CRect  rect; // umisteni v hra.bmp
	int    time_left;
} st_bonus;

typedef struct {
	CPoint p;   // umisteni na hraci plose
	CPoint op;  // minule umisteni
} st_cast;

typedef struct {
	CList<st_cast,st_cast> telo;

	double x_pos_d;
	double y_pos_d;
	double x_speed; // prirustek X 
	double y_speed; // prirustek y
	
	int bmp_y;   // urcuje barvu
	int smer;    // 0,1,2,...23
	int zataceni; // meni smer

	int  carcolour;  // barva auta
	
	int bodu; // nasbiranych bodu 
	int kills; // kolikrat prezil Dead Match

	int speed; // rychlost cerva
	int anim;  // animace smrti
} st_czerw;

class CHra : public Base 
{
public:
	void DeadCont();
	void TestKeys();
	void ShowWinList();
	void OnKeyDown(UINT nChar);
	void OnTimer();
	void Restore();
	void Activate();
	void Move();
	void NewGame(int Players, bool dead = false);
	void TestBonus();
	void UpdateBonus(BOOL bonus = TRUE);
	void UpdateSpeed(int i);
	void UpdateSmer(int i);
	void TestCrash();
	void Draw();

	CHra();
	virtual ~CHra();

	// bitmapy
	LPDIRECTDRAWSURFACE     m_lpDDAll;    // pozadi
	LPDIRECTDRAWSURFACE     m_lpDDHra;    // ostatni - semafor,ramovani,...

	st_bonus  m_bonus;
	CPoint    m_bod;

	st_czerw m_czerwi[2];  // muzou byt bva hraci
	CFont    m_font;
	int      m_players;    // pocet hracu rizenych clovekem ( 0 .. 4 )
	int      m_obtiznost;  // pocet dilku, o kolik had narusta pri jednom body
	bool     m_game;       // kdyz hrac prohraje - aby
	bool     m_pause;
	bool     m_dead;
	CDI_Keyboard m_key;
};

#endif // !defined(AFX_HRA_H__5B2CB4C0_4197_11D3_8F74_83A671FF75B3__INCLUDED_)
