/*******************************************************************************/
//  Bernard Lidicky - 1999
//  Hippo Games
//  CZerw
//  MainFrm.cpp
/*******************************************************************************/

#include "stdafx.h"
#include "CZerwi.h"

#include "bbuttonek.h"

// casti hry
#include "menu1.h"
#include "about.h"

#include "MainFrm.h"


//******************************************************************************

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_PAINT()
	ON_WM_KEYDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_TIMER()
	ON_WM_KEYUP()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_SETCURSOR()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_INITED,Init)
	ON_MESSAGE(WM_MENU,WmMenu)
	ON_MESSAGE(WM_HRA,WmHra)
	ON_MESSAGE(WM_ABOUT,WmAbout)
END_MESSAGE_MAP()

//******************************************************************************
CMainFrame::CMainFrame()
{
	CRect rect;
	rect.bottom = 480;
	rect.left = 0;
	rect.right = 640;
	rect.top = 0;

	CreateEx(WS_EX_TOPMOST,NULL,"CZerwi",
			   WS_POPUP , rect, NULL, 0);

	m_uTimerID = SetTimer(5,40,NULL);

	m_pactual = NULL;
	m_hra = NULL;
	m_menu1 = NULL;
	m_about = NULL;

}
//******************************************************************************
CMainFrame::~CMainFrame()
{
//	KillTimer(m_uTimerID);
	
	m_pactual = NULL;
	if(m_menu1 != NULL) delete m_menu1;
	if(m_about != NULL) delete m_about;
	if(m_hra   != NULL) delete m_hra;
}
//******************************************************************************
void CMainFrame::Init(int parama, int paramb)
{
	TRACE("Initing...\n");
	ZobrazKurzor(FALSE);
	// loadingovani

	// + nacteni
	m_hra = new CHra;
	m_menu1 = new CMenu1;
	m_about = new CAbout;
	SendMessage(WM_MENU);
	SendMessage(WM_TIMER);
	TRACE("Inited...\n");
}

//******************************************************************************
void CMainFrame::FlipScreens()
{
	HRESULT ddrval;
	while( 1 )
	    {
		// prohozeni obrazovek
		ddrval = lpDDSPrimary->Flip( NULL, 0 );
		if( ddrval == DD_OK )  break;
		
		if( ddrval == DDERR_SURFACELOST ) 
			lpDDSPrimary->Restore();
		   
		if( ddrval != DDERR_WASSTILLDRAWING ) break;
		}

}
//******************************************************************************
BOOL CMainFrame::RestoreAll()
{
	return TRUE;
}
//******************************************************************************
void CMainFrame::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	FlipScreens();
}
//******************************************************************************
void CMainFrame::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{

	m_pactual->OnKeyDown(nChar);

	CFrameWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}
//******************************************************************************
void CMainFrame::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	CFrameWnd::OnLButtonDblClk(nFlags, point);
}
//******************************************************************************
void CMainFrame::OnLButtonDown(UINT nFlags, CPoint point) 
{
	m_pactual->OnLButtonDown(point);
	
	CFrameWnd::OnLButtonDown(nFlags, point);
}
//******************************************************************************
void CMainFrame::OnLButtonUp(UINT nFlags, CPoint point) 
{
	m_pactual->OnLButtonUp(point);
	CFrameWnd::OnLButtonUp(nFlags, point);
}
//******************************************************************************
void CMainFrame::OnMouseMove(UINT nFlags, CPoint point) 
{
	m_pactual->OnMouseMove(point);
	CFrameWnd::OnMouseMove(nFlags, point);
}
//******************************************************************************
void CMainFrame::OnTimer(UINT nIDEvent) 
{
	CFrameWnd::OnTimer(nIDEvent);
	if(m_pactual == NULL) return;
	if(!IsIconic()) {
		m_pactual->OnTimer();
		FlipScreens();
	}
}
//******************************************************************************
void CMainFrame::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	m_pactual->OnKeyUp(nChar);
	CFrameWnd::OnKeyUp(nChar, nRepCnt, nFlags);
}
//******************************************************************************
void CMainFrame::WmMenu(int parama, int paramb)
{
	m_menu1->Activate(m_hra);
	m_pactual = m_menu1;
}
//******************************************************************************
void CMainFrame::WmHra(int parama, int paramb)
{
	switch(parama){
	case 1 : 
		m_hra->NewGame(1,false);
		break;
	case 2: 
		m_hra->NewGame(2,false);
		break;
	case 3: 
		m_hra->NewGame(2,true);
		break;
	}
	m_hra->Activate();
	m_pactual = m_hra;
}
//******************************************************************************
void CMainFrame::WmRestore(int parama, int b)
{
	RestoreAll();
}
//******************************************************************************
void CMainFrame::WmAbout(int parama, int paramb)
{
	m_about->Activate();
	m_pactual = m_about;
}
//******************************************************************************
void CMainFrame::OnRButtonDown(UINT nFlags, CPoint point) 
{
	m_pactual->OnRButtonDown(point);
	CFrameWnd::OnRButtonDown(nFlags, point);
}
//******************************************************************************
void CMainFrame::OnRButtonUp(UINT nFlags, CPoint point) 
{
	m_pactual->OnRButtonUp(point);
	CFrameWnd::OnRButtonUp(nFlags, point);
}
//******************************************************************************
BOOL CMainFrame::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{

	return CFrameWnd::OnSetCursor(pWnd, nHitTest, message);
}
