/*******************************************************************************/
//  Bernard Lidicky - 1999
//  Hippo Games
//  CZerw
//  Menu1.cpp
/*******************************************************************************/

#include "stdafx.h"
#include "bbuttonek.h"
#include "CZerwi.h"
#include "Menu1.h"

//******************************************************************************
CMenu1::CMenu1()
{
	m_b1Player = new BButtonek;
	m_b1Player->srect.SetRect(245,145,395,175);
	m_b1Player->menubmp.SetRect(0,480,150,30);

	m_b2Players = new BButtonek;
	m_b2Players->srect.SetRect(245,185,395,215);
	m_b2Players->menubmp.SetRect(0,510,150,30);

	m_bDead = new BButtonek;
	m_bDead->srect.SetRect(245,225,395,255);
	m_bDead->menubmp.SetRect(0,540,150,30);

	m_bAbout = new BButtonek;
	m_bAbout->srect.SetRect(245,265,395,295);
	m_bAbout->menubmp.SetRect(0,570,150,30);

	m_bExit = new BButtonek;
	m_bExit->srect.SetRect(245,305,395,335);
	m_bExit->menubmp.SetRect(0,600,150,30);

	lpDDMenu = DDLoadBitmap(lpDD,"IDB_MENU",0,0); 
	if (lpDDMenu == NULL) {
		TRACE("lpDDMenu == NULL\n");
		AfxGetApp()->m_pMainWnd->SendMessage(WM_CLOSE);
	}
	DDSetColorKey(lpDDMenu, RGB(255,0,255));

	m_font.CreateFont(20,0,0,0,FW_BOLD,0,0,0,1,OUT_DEFAULT_PRECIS, 
						   CLIP_DEFAULT_PRECIS,PROOF_QUALITY,DEFAULT_PITCH,
							"Times New Roman"); // Verdena - Times New Roman
}
//******************************************************************************
CMenu1::~CMenu1()
{
	delete m_b1Player;
	delete m_b2Players;
	delete m_bDead;
	delete m_bAbout;
	delete m_bExit;

	if(lpDDMenu != NULL)  lpDDMenu->Release();
	lpDDMenu = NULL;
}
//******************************************************************************
void CMenu1::OnTimer()
{
	CString s;
	HDC     hdc;
	CRect   rcRect;

	// vlozeni pozadi
	CRect rect;
	rect.SetRect(0,0,640,480);
	HRESULT ddrval;
	while( 1 )   {
		   ddrval = lpDDSBack->BltFast( 0, 0, lpDDMenu,
			  &rect,DDBLTFAST_NOCOLORKEY);
		if( ddrval == DD_OK )  break;
		if( ddrval == DDERR_SURFACELOST ) Restore();
		if( ddrval != DDERR_WASSTILLDRAWING ) return;
	}

	m_b1Player->RedrawButton(lpDDMenu);
	m_b2Players->RedrawButton(lpDDMenu);
	m_bDead->RedrawButton(lpDDMenu);
	m_bAbout->RedrawButton(lpDDMenu);
	m_bExit->RedrawButton(lpDDMenu);
	
	// napsani poctu bodu
	lpDDSBack->GetDC(&hdc);
	SetBkColor(hdc,RGB(0,0,0));
	SetTextColor(hdc,RGB(255,255,255));
	rcRect.SetRect(300,110,340,130);
	s.Format("%d",level);
	DrawText(hdc,s,s.GetLength(),&rcRect,DT_CENTER|DT_VCENTER);
	lpDDSBack->ReleaseDC(hdc);

}
//******************************************************************************
void CMenu1::OnMouseMove(CPoint point)
{
	m_b1Player->MouseMove(point);
	m_b2Players->MouseMove(point);
	m_bDead->MouseMove(point);
	m_bAbout->MouseMove(point);
	m_bExit->MouseMove(point);
}
//******************************************************************************
void CMenu1::OnLButtonDown(CPoint point)
{
	m_b1Player->MouseLBDn(point);
	m_b2Players->MouseLBDn(point);
	m_bDead->MouseLBDn(point);
	m_bAbout->MouseLBDn(point);
	m_bExit->MouseLBDn(point);
}
//******************************************************************************
void CMenu1::OnLButtonUp(CPoint point)
{
	if(m_b1Player->MouseLBUp(point))
		AfxGetApp()->m_pMainWnd->PostMessage(WM_HRA,1);

	if(m_b2Players->MouseLBUp(point))
		AfxGetApp()->m_pMainWnd->PostMessage(WM_HRA,2);

	if(m_bDead->MouseLBUp(point))
		AfxGetApp()->m_pMainWnd->PostMessage(WM_HRA,3);

	if(m_bAbout->MouseLBUp(point))
		AfxGetApp()->m_pMainWnd->PostMessage(WM_ABOUT);


	if(m_bExit->MouseLBUp(point))
		AfxGetApp()->m_pMainWnd->PostMessage(WM_CLOSE);
}
//******************************************************************************
void CMenu1::Activate(CHra *p_hra)
{
	ZobrazKurzor(TRUE);

	m_pHra = p_hra;

	// reset buttonku
	m_b1Player->stav_old = m_b1Player->stav = 0;
	m_b2Players->stav_old = m_b2Players->stav = 0;
	m_bDead->stav_old = m_bDead->stav = 0;
	m_bAbout->stav_old = m_bAbout->stav = 0;
	m_bExit->stav_old = m_bExit->stav = 0;
}
//******************************************************************************
void CMenu1::OnKeyDown(UINT nChar)
{
	switch (nChar) {
	case VK_ESCAPE :
		AfxGetApp()->m_pMainWnd->PostMessage(WM_CLOSE);
		break;
	}
}
//******************************************************************************
void CMenu1::Restore()
{
	lpDDMenu->Restore();
	DDReLoadBitmap(lpDDMenu,"IDB_MENU");

	DDSetColorKey(lpDDMenu, RGB(255,0,255));
}
//******************************************************************************
